//************************************************************
// By Higor
// This channel was made to prevent unwanted function calls
// Keeps the log cleaner
//************************************************************
class XC_CompensatorChannel expands Info;

var XC_LagCompensation LCActor;
var XC_LagCompensator LCComp;
var PlayerPawn LocalPlayer;
var float ffRefireTimer; //This will enforce security checks
var Weapon CurWeapon;
var rotator OldView;
var bool bUseLC;
//If LC is globally disabled, this actor won't exist
var bool bDelayedFire;
var bool bLogTick;
var bool bJustSwitched;

// Shoot flags
// 1 - Use PlayerCalcView
// 2 - Use ZP origin and dir instead of real origin and dir
// 4 - Add range (+10k)
// 8 - Add range (+20k)
// Last 16 bytes = random seed for aim error


struct ShotData
{
	var private Actor ffOther;
	var private Weapon Weap;
	var private int ffID, CmpRot, ShootFlags;
	var private float ffTime;
	var private vector ffHit, ffOff, ffStartTrace;
	var private rotator ffView;
	var private float ffAccuracy;
};
var private ShotData SavedShots[8];
var private int ffISaved;

replication
{
	reliable if ( Role == ROLE_Authority )
		bUseLC;
	reliable if ( Role == ROLE_Authority )
		ffForceLC;
	reliable if ( Role < ROLE_Authority )
		ffSetLC, ffSendHit;
}

//Saves hit info, processes after movement physics occurs
function ffSendHit( Actor ffOther, Weapon Weap, int ffID, float ffTime, vector ffHit, vector ffOff, rotator ffView, vector ffStartTrace, int CmpRot, int ShootFlags, optional float ffAccuracy)
{
	if ( ffISaved > 8 || (Weap == none) )
		return;
	SavedShots[ffISaved].ffOther = ffOther;
	SavedShots[ffISaved].Weap = Weap;
	SavedShots[ffISaved].ffID = ffID;
	SavedShots[ffISaved].ffTime = ffTime;
	SavedShots[ffISaved].ffHit = ffHit;
	SavedShots[ffISaved].ffOff = ffOff;
	SavedShots[ffISaved].ffView = ffView;
	SavedShots[ffISaved].ffStartTrace = ffStartTrace;
	SavedShots[ffISaved].CmpRot = CmpRot;
	SavedShots[ffISaved].ShootFlags = ShootFlags;
	SavedShots[ffISaved].ffAccuracy = ffAccuracy;
	ffISaved++;
}

function ProcessHit( Actor ffOther, Weapon Weap, int ffID, float ffTime, vector ffHit, vector ffOff, rotator ffView, vector ffStartTrace, int CmpRot, int ShootFlags, float ffAccuracy)
{
	local XC_LagCompensator ffLC;
	local vector X, Y, Z, EndTrace;
	local float Range;
	local byte Imprecise;
	local int Seed;

	Imprecise = byte(LCComp.ImpreciseTimer > 0);
	if ( ffAccuracy != 0 )
		Seed = ShootFlags >>> 16;
	if ( !bUseLC || !LCActor.FastValidate( self, ffOther, ffID, Weap, CmpRot, Owner.Location, ffStartTrace, ffHit, Imprecise, ffAccuracy, ShootFlags) ) //NEEDS FIXING!
		return;
	if ( !LCComp.ffClassifyShot(ffTime) ) //Shot denied
	{	Log("Time classification failure");		return;	}

	LCComp.ffCurRegTimer = float(Weap.GetPropertyText("ffRefireTimer")); //Register this timer as current shoot timer
	if ( (LCComp.ImpreciseTimer <= 0) && (Imprecise > 0) ) //Player skipped a security check
		LCComp.ImpreciseTimer = LCComp.ffCurRegTimer * 4;
	LCComp.ffRefireTimer += LCComp.ffCurRegTimer; //Register this new shot in the refire protection

	if  ( ffID != -1 )
		ffOther = LCComp.ffCheckHit( ffID, ffHit, ffOff, ffView);
	
	if ( (ffOther == none) || !Class'LCStatics'.static.RelevantHitActor(ffOther, PlayerPawn(Owner), float(LCComp.ffLastPing) / 1000.0) ) //Shot missed, get another target
	{
		if ( (ShootFlags & 2) == 0 )
		{
			GetAxes( Pawn(Owner).ViewRotation, X, Y, Z);
			if ( (ShootFlags & 1) == 0 )
				ffStartTrace = Owner.Location + Pawn(Owner).BaseEyeheight * vect(0,0,1);
			else
				ffStartTrace = Owner.Location + Weap.CalcDrawOffset() + Weap.FireOffset.Y * Y + Weap.FireOffset.Z * Z;
		}
		else
			GetAxes( rotator(ffHit - ffStartTrace), X, Y, Z);
		Range = 10000;
		if ( (ShootFlags & 4) > 0 )			Range += 10000;
		if ( (ShootFlags & 8) > 0 )			Range += 20000;
		EndTrace = ffStartTrace + X * Range;
		if ( Seed > 0 )
			EndTrace += class'LCStatics'.static.StaticAimError( Y, Z, ffAccuracy, Seed);
		ffOther = Class'LCStatics'.static.ffIrrelevantShot( ffHit, ffOff, EndTrace, ffStartTrace, Pawn(Owner), float(LCComp.ffLastPing) / 1000.0 );
		Weap.ProcessTraceHit( ffOther, ffHit, ffOff, X, Y, Z);
		return;
	}
	ffHit = ffOther.Location + ffOff;
	GetAxes( rotator(ffHit - ffStartTrace), X, Y, Z);
	Weap.ProcessTraceHit( ffOther, ffHit, -X, X, Y, Z);
}

function ffSetLC( bool bEnable)
{
	if ( bUseLC == bEnable )
		ffForceLC( bEnable);
	bUseLC = bEnable;
}

simulated event PostNetBeginPlay()
{
	if ( PlayerPawn(Owner) != none && ViewPort(PlayerPawn(Owner).Player) != none ) 
		LocalPlayer = PlayerPawn(Owner);
	else
		return;

//	if ( LocalPlayer.Weapon != none )    //Register existing weapon
	GotoState('ClientOp');
}

simulated state ClientOp
{
	simulated event Tick( float DeltaTime)
	{
		if ( LocalPlayer.Weapon != CurWeapon )
		{
			if ( LocalPlayer.Weapon != none )
				LocalPlayer.Weapon.KillCredit( self);
			CurWeapon = LocalPlayer.Weapon;
			if ( CurWeapon != none )
				CurWeapon.KillCredit( self);
			bJustSwitched = (TournamentWeapon(CurWeapon) != none);
		}
		if ( bLogTick )
		{
			Log("Channel tick at "$Level.TimeSeconds);
			bLogTick = false;
		}
		if ( bDelayedFire )
			CurWeapon.KillCredit( self);
		if ( bJustSwitched && TournamentWeapon(CurWeapon).bCanClientFire )
		{
			bJustSwitched = false;
			if ( LocalPlayer.bFire > 0 )
				CurWeapon.ClientFire(0);
			else if ( LocalPlayer.bAltFire > 0 )
				CurWeapon.ClientAltFire(0);
			else
				bJustSwitched = true;
		}
	}
Begin:
FindClient:
	Sleep(0.0);
AdjustClient:
//	if ( bUseLC != ClientActor.bUseLC )
//		ffSetLC( ClientActor.bUseLC);
	Sleep(0.5);
	Goto('AdjustClient');
}

function AddPlayer( PlayerPawn Other, XC_LagCompensation Master)
{
	if ( (Other != none) && (NetConnection(Other.Player) != none) && (Master != none) )
	{
		SetOwner( Other);
		LCActor = Master;
		LCComp = LCActor.ffGetLC( Other);
		GotoState('ServerOp');
	}
	else
		Destroy();
}

state ServerOp
{
	event Tick( float DeltaTime)
	{
		local int i;
		While ( i < ffISaved )
		{
			ProcessHit( SavedShots[i].ffOther, SavedShots[i].Weap, SavedShots[i].ffID, SavedShots[i].ffTime, SavedShots[i].ffHit, SavedShots[i].ffOff, SavedShots[i].ffView, SavedShots[i].ffStartTrace, SavedShots[i].CmpRot, SavedShots[i].ShootFlags, SavedShots[i].ffAccuracy);
			SavedShots[i].ffOther = none;
			SavedShots[i].ffID = -1;
			SavedShots[i].Weap = none;
			i++;
		}
		ffISaved = 0;
		if ( Owner != none )
			OldView = Pawn(Owner).ViewRotation;
	}
Begin:
	While ( Owner != none && !Owner.bDeleteMe )
	{
		if ( Pawn(Owner).Weapon != CurWeapon )
		{
			if ( CurWeapon != none )
				CurWeapon.SetPropertyText("LCChan","None");
			CurWeapon = Pawn(Owner).Weapon;
			if ( CurWeapon != none )
				CurWeapon.KillCredit( self);
		}
		Sleep(0.0);
	}
	Destroy();
}

event SetInitialState()
{
	bScriptInitialized = true;
}

event Destroyed()
{
	if ( (CurWeapon != none) && !CurWeapon.bDeleteMe )
		CurWeapon.SetPropertyText("LCChan","None");
}

simulated function ffForceLC( bool bEnable)
{
	bUseLC = bEnable;
}

defaultproperties
{
    bGameRelevant=True
    bHidden=True
    NetPriority=1.1
    NetUpdateFrequency=20
    RemoteRole=ROLE_SimulatedProxy
    bUseLC=True
}